-- main file
 
application:setBackgroundColor(0x000000)
 
local container = Sprite.new()
stage:addChild(container)
container:setPosition(100, 100)
 
local HEIGHT = 400		-- container height
local WIDTH = 400		-- container width
local COUNT = 500		-- number of particles
 
local particles	= {}	-- particle table
local spare	= {}		-- spare particle table

local emissionRate = partTest["maxParticles"] / partTest["particleLifeSpan"]
local imgTexture = Texture.new(partTest["textureName"])
local emitCounter = 0
local elapsed = 0
local rate = 1 / emissionRate
 
function enterFrameHandler(event)
	local dt = event.deltaTime
	updateParticles(dt)
	--print(1/event.deltaTime)
end
 
-- update existing particles
function updateParticles(dt)
	rate = 1 / emissionRate
	emitCounter = emitCounter + dt
	--if #particles < COUNT then
	while #particles < COUNT and emitCounter > rate do
		--addParticles(1)
		local spark = createParticle(math.random(0, WIDTH), math.random(0, 40))
		table.insert(particles, spark)
		emitCounter = emitCounter - rate
	end
	elapsed = elapsed + dt


	local particle
 
	-- check if we hit limit
	if #particles > COUNT then
		particle = table.remove(particles, 1)
		particle:disable()
		table.insert(spare, particle)
	end
 
	-- go through the array of particles...
	local i = 1
	local len = #particles
	local flag = len > 1
 
	while flag do
		-- ... and update each one
 
		particle = particles[i]
		if not particle.disabled then
			particle:update(dt)
			--if particle.sprite:getWidth() < 2 then
			if particle.timeToLive < 0 then
				particle:reset(partTest)
				particle:disable()
				table.insert(spare, table.remove(particles, i))
				-- table size has changed, reflect that in variables
				len = len - 1
				i = i - 1
			end
 
		end
 
		i = i + 1
		-- check whether we reached end of the table
		if i > len then 
			flag = false 
		end
	end
end
 
-- add specified number of new particles
function addParticles(count)
	local spark
	for i = 1, count do
		spark = createParticle(math.random(0, WIDTH), math.random(0, 40))
		table.insert(particles, spark)
	end
end
 
-- draw spark shape, or use image as a particle
function createParticle(x, y)
	local particle
 
	if #spare == 0 then
 
		-- or use image
		--local shape = Bitmap.new(Texture.new("spark.png"))
		local shape = Bitmap.new(imgTexture)
		local w = shape:getWidth()
		local h = shape:getHeight()
		shape:setPosition(-w/2,-h/2)
		container:addChild(shape)
		--container:addChild(shape)
		shape:setPosition(x, y);
		particle = cParticle.new(shape,partTest)
	else 
		-- reuse particle
		particle = table.remove(spare, 1)
		particle.sprite:setPosition(x, y)
		particle:enable()
	end
 
	return particle
end
 
container:addEventListener(Event.ENTER_FRAME, enterFrameHandler);